<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';

interface Tier {
  name: string;
  benefits: string[];
  purchaseUrl: string;
  learnMoreUrl: string;
  ctaPrimary: string;
  ctaSecondary: string;
}

export default Vue.extend({
  props: {
    header: {
      type: String,
      required: true,
    },
    ctaText: {
      type: String,
      required: true,
    },
    learnMoreText: {
      type: String,
      required: false,
      default: 'Learn about',
    },
    buyText: {
      type: String,
      required: false,
      default: 'Buy',
    },
    tiers: {
      type: Array as PropType<Tier[]>,
      required: true,
    },
    footnote: {
      type: String,
      required: false,
      default: '',
    },
  },
});
</script>

<template>
  <SlpContainer>
    <div id="why-gitlab-pricing-tiers">
      <div class="text">
        <SlpTypography variant="heading2-bold">
          {{ header }}
        </SlpTypography>
        <SlpButton
          variant="tertiary"
          data-ga-name="pricing learn more"
          data-ga-location="pricing tier blocks"
          href="/pricing/"
          class="hide-in-mobile"
          >{{ ctaText }} <SlpIcon name="chevron-right" variant="product"
        /></SlpButton>
      </div>
      <div class="tiers-container">
        <div class="tiers">
          <div
            v-for="tier in tiers"
            :key="tier.name"
            class="tier"
            :class="{ ultimate: tier.name === 'Ultimate' }"
          >
            <SlpTypography variant="heading3-bold">{{
              tier.name
            }}</SlpTypography>
            <div class="benefits">
              <div
                v-for="benefit in tier.benefits"
                :key="benefit"
                class="benefit"
              >
                <SlpIcon
                  name="check"
                  class="slp-mr-8"
                  variant="product"
                  alt="Check icon"
                  size="sm"
                />
                <SlpTypography class="slp-pl-16" tag="div" variant="body1">
                  {{ benefit }}
                </SlpTypography>
              </div>
            </div>
            <SlpButton
              :data-ga-name="'Buy ' + tier.name"
              data-ga-location="pricing tier blocks"
              :href="tier.purchaseUrl"
              >{{ buyText || 'Buy' }} GitLab {{ tier.name }}</SlpButton
            >
            <SlpButton
              class="benefit__card"
              variant="tertiary"
              :data-ga-name="tier.name + ' learn more'"
              data-ga-location="pricing tier blocks"
              :href="tier.learnMoreUrl"
              >{{ learnMoreText || 'Learn about' }} {{ tier.name }}
              <SlpIcon name="chevron-right" variant="product"
            /></SlpButton>
          </div>
        </div>
        <SlpTypography variant="body2" tag="div" class="footnote"
          ><div v-html="$md.render(footnote)"></div
        ></SlpTypography>
        <SlpButton
          variant="tertiary"
          data-ga-name="pricing learn more"
          data-ga-location="pricing tier blocks"
          class="mobile-only"
          href="/pricing/"
        >
          {{ ctaText }} <SlpIcon name="chevron-right" variant="product"
        /></SlpButton>
      </div>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
#why-gitlab-pricing-tiers {
  display: flex;
  margin-bottom: 64px;
  flex-direction: column;
  gap: 32px;
  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
  }
  .text {
    display: flex;
    flex-direction: column;
    gap: 28px;
  }
  .tiers-container {
    display: flex;
    flex-direction: column;
    gap: 16px;
    .tiers {
      display: flex;
      flex-direction: column;
      gap: 32px;
      @media (min-width: $breakpoint-lg) {
        flex-direction: row;
      }
      .tier {
        display: flex;
        flex-direction: column;
        align-items: flex-start;
        padding: 32px;
        gap: 16px;
        background: #eee7fd;
        border-radius: 8px;
        .benefits {
          flex: 1;
          display: flex;
          flex-direction: column;
          gap: 16px;
          margin-bottom: 32px;
        }
        .benefit {
          display: flex;
          align-items: center;

          &__card {
            text-align: left;
            display: inline-block;

            .slp-icon {
              display: inline-flex;
              align-items: center;
              position: relative;
              top: 3px;
            }

            @media (min-width: 1170px) {
              align-content: flex-start;
              flex-wrap: wrap;
              padding-right: 0;
            }
          }
        }
        button {
          text-align: left;
          @media (min-width: $breakpoint-lg) {
            white-space: nowrap;
          }
        }
        &.ultimate {
          background: url('/nuxt-images/backgrounds/ultimate_tier_gradient.png');
          background-size: cover;
          border: 1px solid #eee7fd;
          border-radius: 4px 4px 100px 4px;
        }
      }
    }
  }
}
.hide-in-mobile {
  display: none;
  @media (min-width: $breakpoint-lg) {
    display: flex;
  }
}
.mobile-only {
  display: none;
  @media (max-width: $breakpoint-lg) {
    display: flex;
  }
}
</style>
